import Notification from "./notification-group.vue";
import {h, render, VNode} from 'vue'
import {NotificationProps} from "./types";

let vNode: VNode | null = null;

function getInstance() {
    if (!vNode) {
        vNode = h(Notification, {
            ref:'noticeNode'
        })
        let noticeWrapper = document.querySelector<HTMLDivElement>('.notice-wrapper-c')

        if (!noticeWrapper) {
            noticeWrapper = document.createElement('div')
            noticeWrapper.classList.add('notice-wrapper-c')
            document.body.appendChild(noticeWrapper)
        }
        render(vNode, noticeWrapper)
    }
    return vNode?.component?.exposed;
}

function showNotification(prop: NotificationProps) {
    const instance = getInstance();
    instance?.addNotice?.(prop)
}


export const message = {
    show(content: string, title?: string,duration = 3) {
        showNotification({
            type: 'notice',
            content,
            title,
            duration,
            closable:true
        })
    }
}
