import {md5} from "js-md5";
import dayjs from "dayjs";

export function getMd5(str: string) {
	return md5(str);
}

export function formatDatetime(date: Date | string | number, format = 'YYYY-MM-DD HH:mm:ss') {
	if (!date) return date;
	return dayjs(date).format(format);
}

export function parseExpression(str: string) {
	if (!str) return '';
	const doc = JSON.parse(str) as TiptapContentValue;
	if (!doc.content || doc.content.length == 0) {
		return '';
	}
	const expList: string[] = [];
	doc.content.forEach(p=>{
		const expressionList = p.content;
		if (!expressionList) return;
		const expression = expressionList.map(item => {
			if (item.type == 'text') {
				return item.text;
			}
			return item.attrs.id
		}).join('');
		expList.push(expression);
	})
	return expList.join('');
}