import { sleep } from "@/core/sleep";
import { post } from "./request";

export const ProductCols = [
    { id: 1, name: "能量密度", alias: "power" },
    { id: 2, name: "蛋白Pro", alias: "protein" },
    { id: 3, name: "Glu", alias: "glu" },
    { id: 4, name: "Fat", alias: "fat" },
    { id: 5, name: "纤维素", alias: "cellulose" },
    { id: 6, name: "Na", alias: "na" },
    { id: 7, name: "K", alias: "k" },
    { id: 8, name: "Ca", alias: "ca" },
    { id: 9, name: "P", alias: "p" },
    { id: 10, name: "Mg", alias: "mg" },
];

export async function getList(param: ProductSearchParam) {
    await sleep(200);
    return await post<DataList<ProductInfoModel>>(`/product/all`, param);
}

export function deleteProduct(id: number) {
    return post(`/product/delete`, { id })
}
export async function saveProduct(params: Partial<ProductInfoModel>) {
    await sleep(200);
    return await post(`/product/save`, params);
}
