import {DirectiveBinding, ObjectDirective} from "vue";

export const ClickOutsideDirective: ObjectDirective = {
    beforeMount(el: HTMLElement, binding: DirectiveBinding) {

        function documentHandler(e: any ) {
            if (el.contains(e.target)) {
                return false;
            }
            binding.value?.(e);
        }

        //@ts-ignore
        el.__vueClickOutside__ = documentHandler;
        document.addEventListener('click', documentHandler);
    },

    unmounted(el: HTMLElement) {
        //@ts-ignore
        document.removeEventListener('click', el.__vueClickOutside__);
        //@ts-ignore
        delete el.__vueClickOutside__;
    },
}
