export type BaseModel = {
    id: number;
    name: string;
    alias?: string;
};
export type ProductFieldValue = {
    id: number;
    alias?: string;
    product_id: number;
    field_id: number;
    value: number;
};
export type ProductValue = {
    product: BaseModel;
    values: ProductFieldValue[];
};
export const fields: BaseModel[] = [
    { id: 1, name: "能量密度", alias: "power" },
    { id: 2, name: "蛋白Pro", alias: "protein" },
    { id: 3, name: "Glu", alias: "glu" },
    { id: 4, name: "Fat", alias: "fat" },
    { id: 5, name: "纤维素", alias: "cellulose" },
    { id: 6, name: "Na", alias: "na" },
    { id: 7, name: "K", alias: "k" },
    { id: 8, name: "Ca", alias: "ca" },
    { id: 9, name: "P", alias: "p" },
    { id: 10, name: "Mg", alias: "mg" },
    { id: 10, name: "计量单位", alias: "unit" },
];
export const products: BaseModel[] = [
    { id: 1, name: "爱伦多", alias: "ailunduo" },
    { id: 2, name: "维沃", alias: "weiwo" },
    { id: 3, name: "佳维体", alias: "jiaweiti" },
    { id: 4, name: "伊力佳", alias: "yilijia" },
];

const PRODUCT_VALUES_KEY = "PRODUCT_VALUES_KEY";
const product_values_default: ProductFieldValue[] = [
    {
        id: 1,
        product_id: 1,
        field_id: 1,
        value: 0,
        alias: "ailunduo_power",
    },
    { id: 2, product_id: 1, field_id: 2, value: 0, alias: "ailunduo_protein" },
    {
        id: 3,
        product_id: 1,
        field_id: 3,
        value: 0,
        alias: "ailunduo_glu",
    },
    { id: 4, product_id: 1, field_id: 4, value: 0, alias: "ailunduo_fat" },
    {
        id: 5,
        product_id: 1,
        field_id: 5,
        value: 0,
        alias: "ailunduo_cellulose",
    },
    { id: 6, product_id: 1, field_id: 6, value: 0, alias: "ailunduo_na" },
    {
        id: 7,
        product_id: 1,
        field_id: 7,
        value: 0,
        alias: "ailunduo_k",
    },
    { id: 8, product_id: 1, field_id: 8, value: 0, alias: "ailunduo_ca" },
    {
        id: 9,
        product_id: 1,
        field_id: 9,
        value: 0,
        alias: "ailunduo_p",
    },
    { id: 10, product_id: 1, field_id: 10, value: 0, alias: "ailunduo_mg" },
    {
        id: 11,
        product_id: 2,
        field_id: 1,
        value: 0,
        alias: "weiwo_power",
    },
    { id: 12, product_id: 2, field_id: 2, value: 0, alias: "weiwo_protein" },
    {
        id: 13,
        product_id: 2,
        field_id: 3,
        value: 0,
        alias: "weiwo_glu",
    },
    { id: 14, product_id: 2, field_id: 4, value: 0, alias: "weiwo_fat" },
    {
        id: 15,
        product_id: 2,
        field_id: 5,
        value: 0,
        alias: "weiwo_cellulose",
    },
    { id: 16, product_id: 2, field_id: 6, value: 0, alias: "weiwo_na" },
    {
        id: 17,
        product_id: 2,
        field_id: 7,
        value: 0,
        alias: "weiwo_k",
    },
    { id: 18, product_id: 2, field_id: 8, value: 0, alias: "weiwo_ca" },
    {
        id: 19,
        product_id: 2,
        field_id: 9,
        value: 0,
        alias: "weiwo_p",
    },
    { id: 20, product_id: 2, field_id: 10, value: 0, alias: "weiwo_mg" },
    {
        id: 21,
        product_id: 3,
        field_id: 1,
        value: 0,
        alias: "jiaweiti_power",
    },
    { id: 22, product_id: 3, field_id: 2, value: 0, alias: "jiaweiti_protein" },
    {
        id: 23,
        product_id: 3,
        field_id: 3,
        value: 0,
        alias: "jiaweiti_glu",
    },
    { id: 24, product_id: 3, field_id: 4, value: 0, alias: "jiaweiti_fat" },
    {
        id: 25,
        product_id: 3,
        field_id: 5,
        value: 0,
        alias: "jiaweiti_cellulose",
    },
    { id: 26, product_id: 3, field_id: 6, value: 0, alias: "jiaweiti_na" },
    {
        id: 27,
        product_id: 3,
        field_id: 7,
        value: 0,
        alias: "jiaweiti_k",
    },
    { id: 28, product_id: 3, field_id: 8, value: 0, alias: "jiaweiti_ca" },
    {
        id: 29,
        product_id: 3,
        field_id: 9,
        value: 0,
        alias: "jiaweiti_p",
    },
    { id: 30, product_id: 3, field_id: 10, value: 0, alias: "jiaweiti_mg" },
    {
        id: 31,
        product_id: 4,
        field_id: 1,
        value: 0,
        alias: "yilijia_power",
    },
    { id: 32, product_id: 4, field_id: 2, value: 0, alias: "yilijia_protein" },
    {
        id: 33,
        product_id: 4,
        field_id: 3,
        value: 0,
        alias: "yilijia_glu",
    },
    { id: 34, product_id: 4, field_id: 4, value: 0, alias: "yilijia_fat" },
    {
        id: 35,
        product_id: 4,
        field_id: 5,
        value: 0,
        alias: "yilijia_cellulose",
    },
    { id: 36, product_id: 4, field_id: 6, value: 0, alias: "yilijia_na" },
    {
        id: 37,
        product_id: 4,
        field_id: 7,
        value: 0,
        alias: "yilijia_k",
    },
    { id: 38, product_id: 4, field_id: 8, value: 0, alias: "yilijia_ca" },
    {
        id: 39,
        product_id: 4,
        field_id: 9,
        value: 0,
        alias: "yilijia_p",
    },
    { id: 40, product_id: 4, field_id: 10, value: 0, alias: "yilijia_mg" },
];

export function getProductValues() {
    const sessionData = localStorage.getItem(PRODUCT_VALUES_KEY);
    const product_values: ProductFieldValue[] = sessionData
        ? JSON.parse(sessionData)
        : product_values_default;
    const values: Record<number, ProductFieldValue[]> = {};
    product_values.forEach((s) => {
        if (!values[s.product_id]) values[s.product_id] = [];
        values[s.product_id].push(s);
    });
    const results: ProductValue[] = products.map((product) => ({
        product,
        values: values[product.id],
    }));
    console.log(results);
    return results;
}

export function saveProductValues(datas: ProductValue[]) {
    const values = datas.map((s) => s.values).flatMap((s) => s);
    localStorage.setItem(PRODUCT_VALUES_KEY, JSON.stringify(values));
}

// const product_values: ProductFieldValue[] = []
// let id = 1;
// products.forEach(p => {
//     fields.forEach(f => {
//         product_values.push({
//             id: id++,
//             product_id: p.id,
//             field_id: f.id,
//             value: 0,
//             alias: `${p.alias}_${f.alias}`
//         })
//     })
// })
// console.log(JSON.stringify(product_values))
