declare type ProductSearchParam = {
	page: number;
	limit: number;
	name?: string;
	category?: string;
}

declare type ProductInfoModel = {
	id: number;
	name: string;
	alias: string;
	category: string;
	unit: string;
	power: number;
	protein: number;
	glu: number;
	fat: number;
	cellulose: number;
	na: number;
	k: number;
	ca: number;
	p: number;
	mg: number;
	created_at: Date | string;
	updated_at: Date | string;
	status: number;
}

declare type ResultExpression = {
	id: number;
	key: string;
	title: string;
	alias: string;
	expression: string;
	created_at: Date | string;
	updated_at: Date | string;
	status: number;
}
declare type ResultVarItem = {
	label: string;
	value: string;
	text?: string;
}
declare type TiptapContentValue = {
	type:string;
	content: {
		type:string;
		content: ExpressionValue[];
	}[];
}

interface ExpressionValue {
	type: 'text'|'mention';
	attrs: {
		id: string;
		label: string;
	}
	text: string;
}


interface ResultItem {
	title:string;
	key:string;
	value:number;
}